-- GNU GENERAL PUBLIC LICENSE Version 3
-- Created by Monk3yDev 
-- I will be so happy when this addon become popular.
-- If you want use code from DestroyusPro
-- please let me know about it monk3ydev at gmail dot com 


DestroyusPro = {}
local frame = CreateFrame("Frame", "DestroyusPro")
frame:RegisterEvent("ADDON_LOADED")

-- Milling --
local ClickMeForWorkMilling = CreateFrame("Button", "ClickMeForWorkMilling", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkMilling:SetAttribute("type", "macro")
ClickMeForWorkMilling:SetAttribute("macrotext", "/cry")

-- Disenchant --
local ClickMeForWorkDisenchanting = CreateFrame("Button", "ClickMeForWorkDisenchanting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkDisenchanting:SetAttribute("type", "macro")
ClickMeForWorkDisenchanting:SetAttribute("macrotext", "/cry")

-- Prospecting --
local ClickMeForWorkProspecting = CreateFrame("Button", "ClickMeForWorkProspecting", UIParent, "SecureActionButtonTemplate")
ClickMeForWorkProspecting:SetAttribute("type", "macro")
ClickMeForWorkProspecting:SetAttribute("macrotext", "/cry")

local function loadAddonData(self, event, arg1)
    if event == "ADDON_LOADED" and arg1 == 'DestroyusPro' then
		if _G["DestroyusProInitDataFirstLoad"] == nil then
			_G["DestroyusProInitDataFirstLoad"] = true
			_G["DestroyusProItemQualityValue"] = 2
		end
		local msg = "DestroyusPro Addon sucessfuly loaded. Quiality of items %s"
	    print(msg:format(DestroyusPro.numToStrQuality[_G["DestroyusProItemQualityValue"]]))
	end
end

local function clickMacroButton(self, event)
	self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Disenchant"))
end

local function clickMacroButtonMilling(self, event)
	self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Milling"))
end

local function clickMacroButtonProspecting(self, event)
	self:SetAttribute("macrotext", DestroyusPro.createMacroUsage("Prospecting"))
end

frame:SetScript("OnEvent", loadAddonData)
ClickMeForWorkDisenchanting:SetScript("PreClick", clickMacroButton)
ClickMeForWorkMilling:SetScript("PreClick", clickMacroButtonMilling)
ClickMeForWorkProspecting:SetScript("PreClick", clickMacroButtonProspecting)


function DestroyusPro.isItemDisenchantableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemDisenchantable(containerItemInfoTab["itemId"],
								             containerItemInfoTab["count"],
								             containerItemInfoTab["isNotSellable"])
end

function DestroyusPro.isItemMillingableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemMillingable(containerItemInfoTab["itemId"],
										  containerItemInfoTab["count"],
										  containerItemInfoTab["isNotSellable"])
end

function DestroyusPro.isItemProspectingableInBag(i, j)
    local containerItemInfoTab = DestroyusPro.createContainerItemInfoTab(i, j)
	return DestroyusPro.isItemProspectingable(containerItemInfoTab["itemId"], 
								              containerItemInfoTab["count"],
								              containerItemInfoTab["isNotSellable"])
end

DestroyusPro.isItemProffesionInBag = {}
DestroyusPro.isItemProffesionInBag["Disenchant"] = DestroyusPro.isItemDisenchantableInBag
DestroyusPro.isItemProffesionInBag["Milling"] = DestroyusPro.isItemMillingableInBag
DestroyusPro.isItemProffesionInBag["Prospecting"] = DestroyusPro.isItemProspectingableInBag

function DestroyusPro.findItemToWork(proffesion)
    local result = {itemFound=false, i=0 ,j=0}
	for i=0,4 do 
		for j=1,GetContainerNumSlots(i) do 
			if DestroyusPro.isItemProffesionInBag[proffesion](i,j) then
			    local itemInfo = DestroyusPro.createContainerItemInfoTab(i,j)
				result["itemFound"] = true
				result["i"] = i
				result["j"] = j
				result["link"] = itemInfo["link"]
				result["itemId"] = itemInfo["itemId"]
				break
			end 
		end 
	end
	return result
end

-- Refactoring
-- Method should not print values 
-- Only return value 
function DestroyusPro.createMacroUsage(proffesion)
	local macroStr = '/cast '..proffesion..'\n/use %d %d'
	local result = DestroyusPro.findItemToWork(proffesion)
	if result["itemFound"] then
		macroStr = macroStr:format(result["i"], result["j"])
		print(""..proffesion.." => " .. result["link"] .. " ItemId: " .. result["itemId"])
	else
		macroStr = ""
		local msg = "Quiality of items %s"
		local informQualityDisenchant = proffesion == "Disenchant" and msg:format(DestroyusPro.numToStrQuality[_G["DestroyusProItemQualityValue"]]) or ""
		print("Nothing to "..proffesion.."!" .. " " .. informQualityDisenchant)
	end
	return macroStr
end


function DestroyusPro.isItemDisenchantable(itemId, _, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isItem(itemInfoTab["class"], itemInfoTab["subclass"], itemInfoTab["equipslot"]) and
	       DestroyusPro.isOnlyOneMaxStack(itemInfoTab["maxstack"]) and 
		   DestroyusPro.isNotUniqueItem(itemId, DestroyusPro.itemsIdNotForDisenchant) and
		   DestroyusPro.isQualityAllowed(itemInfoTab["quality"]) and
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.isItemEquippable(itemId) and
		   DestroyusPro.haveItemRequiredProfLvlDisenchant("Enchanting", itemInfoTab["ilevel"], itemInfoTab["quality"])
end

function DestroyusPro.isItemMillingable(itemId, count, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isHerb(itemInfoTab["class"], itemInfoTab["subclass"]) and 
		   DestroyusPro.isQualityHerbAllowed(itemInfoTab["quality"]) and
		   DestroyusPro.isItemNotConsumable(itemId) and 
		   DestroyusPro.isStackAmountEnough(count) and
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.isNotUniqueItem(itemId, DestroyusPro.itemsIdNotForMilling) and
		   DestroyusPro.haveItemRequiredProfLvl(itemInfoTab["name"], "Inscription", DestroyusPro.herbsIlvl)
end

function DestroyusPro.isItemProspectingable(itemId, count, isNotSellable)
	local itemInfoTab = DestroyusPro.createItemInfoTab(itemId)
	return DestroyusPro.isOre(itemInfoTab["class"], itemInfoTab["subclass"], itemInfoTab["name"]) and
		   DestroyusPro.isItemNotConsumable(itemId) and 
		   DestroyusPro.isStackAmountEnough(count) and 
		   DestroyusPro.isItemNotSellable(isNotSellable) and
		   DestroyusPro.haveItemRequiredProfLvl(itemInfoTab["name"], "Jewelcrafting", DestroyusPro.oresIlvl)
end

function DestroyusPro.createItemInfoTab(itemId)
	local itemValues
	if itemId == nil then
		itemValues = {nil, nil, nil, nil, nil, nil, nil, nil, nil, nil}
	else
		itemValues = {GetItemInfo(itemId)}
	end
	local itemInfoTab = {}
	itemInfoTab["name"] = itemValues[1]
	itemInfoTab["link"] = itemValues[2]
	itemInfoTab["quality"] = itemValues[3]
	itemInfoTab["ilevel"] = itemValues[4]
	itemInfoTab["reqlevel"] = itemValues[5]
	itemInfoTab["class"] = itemValues[6]
	itemInfoTab["subclass"] = itemValues[7]
	itemInfoTab["maxstack"] = itemValues[8]
	itemInfoTab["equipslot"] = itemValues[9]
	itemInfoTab["texture"] = itemValues[10]
	itemInfoTab["vendorprice"] = itemValues[11]
	itemInfoTab["argUnknow"] = itemValues[12]
	return itemInfoTab
end

function DestroyusPro.createContainerItemInfoTab(i, j) 
	local itemValues = {GetContainerItemInfo(i,j)}
	local itemInfoTab = {}
	itemInfoTab["texture"] = itemValues[1]
	itemInfoTab["count"] = itemValues[2]
	itemInfoTab["locked"] = itemValues[3]
	itemInfoTab["quality"] = itemValues[4]
	itemInfoTab["readable"] = itemValues[5]
	itemInfoTab["lootable"] = itemValues[6]
	itemInfoTab["link"] = itemValues[7]
	itemInfoTab["isFiltered"] = itemValues[8]
	itemInfoTab["isNotSellable"] = itemValues[9]
	itemInfoTab["itemId"] = itemValues[10]
	
	return itemInfoTab
end