DestroyusPro.materialsRequireInStack = 5
DestroyusPro.professionIdNotExist = -1

DestroyusPro.itemClassHerb = {}
DestroyusPro.itemClassHerb["Tradeskill"] = true
DestroyusPro.itemClassHerb["Herb"] = true

DestroyusPro.itemClassOre = {}
DestroyusPro.itemClassOre["Tradeskill"] = true
DestroyusPro.itemClassOre["Metal & Stone"] = true
DestroyusPro.itemClassOre["Black Trillium Ore"] = true
DestroyusPro.itemClassOre["White Trillium Ore"] = true
DestroyusPro.itemClassOre["Kyparite"] = true
DestroyusPro.itemClassOre["Ghost Iron Ore"] = true	
DestroyusPro.itemClassOre["Pyrite Ore"] = true
DestroyusPro.itemClassOre["Elementium Ore"] = true
DestroyusPro.itemClassOre["Obsidium Ore"] = true
DestroyusPro.itemClassOre["Titanium Ore"] = true
DestroyusPro.itemClassOre["Saronite Ore"] = true
DestroyusPro.itemClassOre["Cobalt Ore"] = true
DestroyusPro.itemClassOre["Adamantite Ore"] = true
DestroyusPro.itemClassOre["Fel Iron Ore"] = true
DestroyusPro.itemClassOre["Mithril Ore"] = true
DestroyusPro.itemClassOre["Thorium Ore"] = true
DestroyusPro.itemClassOre["Iron Ore"] = true
DestroyusPro.itemClassOre["Tin Ore"] = true
DestroyusPro.itemClassOre["Copper Ore"] = true


ExtraTabFun.setDefault(DestroyusPro.itemClassOre, false)
ExtraTabFun.setDefault(DestroyusPro.itemClassHerb, false)

function DestroyusPro.isQualityHerbAllowed(quality)
	return quality >= DestroyusPro.strToNumQuality["common"] and 
		   quality <= DestroyusPro.strToNumQuality["uncommon"] 
end

function DestroyusPro.isItemNotConsumable(itemId)
	return not IsConsumableItem(itemId)
end

function DestroyusPro.isStackAmountEnough(amount)
	return amount >= DestroyusPro.materialsRequireInStack
end

function DestroyusPro.isHerb(class, subClass)
	return DestroyusPro.itemClassHerb[class] and DestroyusPro.itemClassHerb[subClass]
end

function DestroyusPro.isOre(class, subClass, itemName)
	return DestroyusPro.itemClassOre[class] and DestroyusPro.itemClassOre[subClass] and 
		   DestroyusPro.itemClassOre[itemName]
end

function DestroyusPro.haveItemRequiredProfLvl(itemName, proffesion, itemsIlvl)
    local result = true
	local proffesionTabIds = DestroyusPro.getProffessionsId()
	local firstProffesion = DestroyusPro.getProffessionInfo(proffesionTabIds["firstProffesion"])
	local secondProffesion =  DestroyusPro.getProffessionInfo(proffesionTabIds["secondProffesion"])
	if firstProffesion["name"] == proffesion then
		result = itemsIlvl[itemName] <= firstProffesion["skillLevel"]
	elseif secondProffesion["name"] == proffesion then
		result = itemsIlvl[itemName] <= secondProffesion["skillLevel"]
	else
		result = false
	end
	
	return result
end

function DestroyusPro.getProffessionsId()
	local profTab = {GetProfessions()}
	local proffesionTab = {}
	proffesionTab["firstProffesion"] = profTab[1] ~= nil and profTab[1] or DestroyusPro.professionIdNotExist
	proffesionTab["secondProffesion"] = profTab[2] ~= nil and profTab[2] or DestroyusPro.professionIdNotExist
	proffesionTab["archaeology"] = profTab[3] ~= nil and profTab[3] or DestroyusPro.professionIdNotExist
	proffesionTab["fishing"] = profTab[4] ~= nil and profTab[4] or DestroyusPro.professionIdNotExist
	proffesionTab["cooking"] = profTab[5] ~= nil and profTab[5] or DestroyusPro.professionIdNotExist
	proffesionTab["firstAid"] = profTab[6] ~= nil and profTab[6] or DestroyusPro.professionIdNotExist
	return proffesionTab
end

function DestroyusPro.getProffessionInfo(index)
	local profTab = {GetProfessionInfo(index)}
	local proffesionTab = {}
	proffesionTab["name"] = profTab[1]
	proffesionTab["icon"] = profTab[2] 
	proffesionTab["skillLevel"] = profTab[3] 
	proffesionTab["maxSkillLevel"] = profTab[4] 
	proffesionTab["numAbilities"] = profTab[5] 
	proffesionTab["spelloffset"] = profTab[6] 
	proffesionTab["skillLine"] = profTab[7]
	proffesionTab["skillModifier"] = profTab[8] 
	proffesionTab["specializationIndex"] = profTab[9]
	proffesionTab["specializationOffset"] = profTab[10]
	return proffesionTab
end