DestroyusPro.oneItemOnStack = 1
DestroyusPro.skillLvlNotExist = 9999999

DestroyusPro.itemClassWeapon = {}
DestroyusPro.itemClassWeapon["Weapon"] = true 
DestroyusPro.itemClassWeapon["One-Handed Axes"] = true
DestroyusPro.itemClassWeapon["Two-Handed Axes"] = true 
DestroyusPro.itemClassWeapon["Bows"] = true 
DestroyusPro.itemClassWeapon["Guns"] = true 
DestroyusPro.itemClassWeapon["One-Handed Maces"] = true 
DestroyusPro.itemClassWeapon["Two-Handed Maces"] = true 
DestroyusPro.itemClassWeapon["Polearms"] = true 
DestroyusPro.itemClassWeapon["One-Handed Swords"] = true 
DestroyusPro.itemClassWeapon["Two-Handed Swords"] = true 
DestroyusPro.itemClassWeapon["Staves"] = true 
DestroyusPro.itemClassWeapon["Fist Weapons"] = true 
DestroyusPro.itemClassWeapon["Daggers"] = true 
DestroyusPro.itemClassWeapon["Thrown"] = true 
DestroyusPro.itemClassWeapon["Wands"] = true 
DestroyusPro.itemClassWeapon["Crossbows"] = true 
DestroyusPro.itemClassWeapon["Warglaives"] = true

DestroyusPro.itemClassArmor = {}
DestroyusPro.itemClassArmor["Armor"] = true
DestroyusPro.itemClassArmor["Cloth"] = true
DestroyusPro.itemClassArmor["Leather"] = true
DestroyusPro.itemClassArmor["Mail"] = true
DestroyusPro.itemClassArmor["Plate"] = true
DestroyusPro.itemClassArmor["Shields"] = true

DestroyusPro.itemClassMiscellaneous = {}
DestroyusPro.itemClassMiscellaneous["Armor"] = true
DestroyusPro.itemClassMiscellaneous["Miscellaneous"] = true
DestroyusPro.itemClassMiscellaneous["INVTYPE_TRINKET"] = true
DestroyusPro.itemClassMiscellaneous["INVTYPE_NECK"] = true
DestroyusPro.itemClassMiscellaneous["INVTYPE_FINGER"] = true
DestroyusPro.itemClassMiscellaneous["INVTYPE_HOLDABLE"] = true

DestroyusPro.strToNumQuality = {}
DestroyusPro.strToNumQuality["rare"] = 3
DestroyusPro.strToNumQuality["epic"] = 4
DestroyusPro.strToNumQuality["uncommon"] = 2
DestroyusPro.strToNumQuality["common"] = 1

DestroyusPro.numToStrQuality = {}
DestroyusPro.numToStrQuality[1] = "common"
DestroyusPro.numToStrQuality[2] = "uncommon"
DestroyusPro.numToStrQuality[3] = "rare"
DestroyusPro.numToStrQuality[4] = "epic"

ExtraTabFun.setDefault(DestroyusPro.itemClassWeapon, false)
ExtraTabFun.setDefault(DestroyusPro.itemClassArmor, false)
ExtraTabFun.setDefault(DestroyusPro.itemClassMiscellaneous, false)
ExtraTabFun.setDefault(DestroyusPro.strToNumQuality, -1)
ExtraTabFun.setDefault(DestroyusPro.numToStrQuality, "?unknow!")

function DestroyusPro.isItemNotSellable(isSellable)
	return not isSellable
end

function DestroyusPro.isQualityAllowed(quality)
	return (quality >= DestroyusPro.strToNumQuality["uncommon"] and quality <= _G["DestroyusProItemQualityValue"])
end

function DestroyusPro.isNotUniqueItem(itemId, uniqueItemList)
	local result = true
	for	_, uniqueItemId in ipairs(uniqueItemList) do
		if uniqueItemId == itemId then
		    result = false
		break
		end
	end
	return result 
end

function DestroyusPro.isOnlyOneMaxStack(maxStack)
	return maxStack == DestroyusPro.oneItemOnStack
end

function DestroyusPro.isItem(class, subClass, equipSlot)
	return DestroyusPro.isWeapon(class, subClass) or 
	       DestroyusPro.isArmor(class, subClass) or
	       DestroyusPro.isMiscellaneous(class, subClass, equipSlot)
end

function DestroyusPro.isWeapon(class, subClass)
	return DestroyusPro.itemClassWeapon[class] and 
	       DestroyusPro.itemClassWeapon[subClass]
end

function DestroyusPro.isArmor(class, subClass)
	return DestroyusPro.itemClassArmor[class] and 
		   DestroyusPro.itemClassArmor[subClass]
end

function DestroyusPro.isMiscellaneous(class, subClass, equipSlot)
	return DestroyusPro.itemClassMiscellaneous[class] and 
		   DestroyusPro.itemClassMiscellaneous[subClass] and
	       DestroyusPro.itemClassMiscellaneous[equipSlot]
end

function DestroyusPro.isItemEquippable(itemId)
	return IsEquippableItem(itemId)
end

function DestroyusPro.getItemProffLvlToDisUncommon(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 20 then
		result = 1
	elseif 21 <= itemILvl and itemILvl <= 25 then
		result = 25
	elseif 26 <= itemILvl and itemILvl <= 30 then
		result = 50
	elseif 31 <= itemILvl and itemILvl <= 35 then
		result = 75
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 101 then
		result = 225
	elseif 102 <= itemILvl and itemILvl <= 120 then
		result = 275
	elseif 121 <= itemILvl and itemILvl <= 150 then
		result = 325
	elseif 151 <= itemILvl and itemILvl <= 271 then
		result = 350
	elseif 272 <= itemILvl and itemILvl <= 363 then
		result = 425
	elseif 364 <= itemILvl and itemILvl <= 469 then
		result = 475
	elseif 470 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)		
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisRare(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 25 then
		result = 25
	elseif 26 <= itemILvl and itemILvl <= 30 then
		result = 50
	elseif 31 <= itemILvl and itemILvl <= 35 then
		result = 75
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 99 then
		result = 225
	elseif 100 <= itemILvl and itemILvl <= 124 then
		result = 275
	elseif 125 <= itemILvl and itemILvl <= 218 then
		result = 325
	elseif 219 <= itemILvl and itemILvl <= 377 then
		result = 450
	elseif 378 <= itemILvl and itemILvl <= 424 then
		result = 525
	elseif 425 <= itemILvl and itemILvl <= 505 then
		result = 550
	elseif 506 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)		
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisEpic(itemILvl)
	local result = 1
	if 1 <= itemILvl and itemILvl <= 35 then
		result = 25
	elseif 36 <= itemILvl and itemILvl <= 40 then
		result = 100
	elseif 41 <= itemILvl and itemILvl <= 45 then
		result = 125
	elseif 46 <= itemILvl and itemILvl <= 50 then
		result = 150
	elseif 51 <= itemILvl and itemILvl <= 55 then
		result = 175
	elseif 56 <= itemILvl and itemILvl <= 60 then
		result = 200
	elseif 61 <= itemILvl and itemILvl <= 99 then
		result = 225
	elseif 100 <= itemILvl and itemILvl <= 199 then
		result = 300
	elseif 200 <= itemILvl and itemILvl <= 350 then
		result = 375
	elseif 351 <= itemILvl and itemILvl <= 419 then
		result = 475
	elseif 420 <= itemILvl and itemILvl <= 629 then
		result = 575
	elseif 630 <= itemILvl then
		result = 1
	else
		result = DestroyusPro.getItemProffLvlToDisRest(itemILvl)	
	end
	return result
end

function DestroyusPro.getItemProffLvlToDisRest(itemILvl)
	return DestroyusPro.skillLvlNotExist
end

DestroyusPro.selectQualityProfIlvl = {}
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["uncommon"]] = DestroyusPro.getItemProffLvlToDisUncommon 
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["rare"]] = DestroyusPro.getItemProffLvlToDisRare
DestroyusPro.selectQualityProfIlvl[DestroyusPro.strToNumQuality["epic"]] = DestroyusPro.getItemProffLvlToDisEpic
ExtraTabFun.setDefault(DestroyusPro.selectQualityProfIlvl, DestroyusPro.getItemProffLvlToDisRest)

function DestroyusPro.getItemProffLvlToDis(itemILvl, quality)
   itemILvl = itemILvl ~= nil and itemILvl or DestroyusPro.skillLvlNotExist
   return DestroyusPro.selectQualityProfIlvl[quality](itemILvl)
end

function DestroyusPro.haveItemRequiredProfLvlDisenchant(proffesion, itemsIlvl, quality)
    local result = true
	local proffesionTabIds = DestroyusPro.getProffessionsId()
	local firstProffesion = DestroyusPro.getProffessionInfo(proffesionTabIds["firstProffesion"])
	local secondProffesion =  DestroyusPro.getProffessionInfo(proffesionTabIds["secondProffesion"])
	if firstProffesion["name"] == proffesion then
		result = DestroyusPro.getItemProffLvlToDis(itemILvl, quality) <= secondProffesion["skillLevel"]
	elseif secondProffesion["name"] == proffesion then
		result = DestroyusPro.getItemProffLvlToDis(itemILvl, quality) <= secondProffesion["skillLevel"]
	else
		result = false
	end
	return result
end