local ASCII_0_NUMBER = 48
local ASCII_9_NUMBER = 57
SLASH_DISENCH1 = '/disenchantus' --disenchantus
SLASH_MILLINGUS1 = '/millingus'  --millingus
SLASH_PROSPECTINGUS1 = '/prospectingus'  --prospectingus

local function changeQualityDisenchanting(quality)
	_G["DestroyusProItemQualityValue"] = DestroyusPro.strToNumQuality[quality]
	ReloadUI()
end

local function unknownCommand(command)
    if command == nil then
		command = ""
	end
	local commandMsg = "Uknown value for the command: %s"
	print(commandMsg:format(command))
end

local function createMacroDisenchanting()
	if _G["DestroyusProDisenchantMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProDisenchantMacroId"])
	end
		_G["DestroyusProDisenchantMacroId"] = CreateMacro("Disenchantus", "645142", "/click ClickMeForWorkDisenchanting")
	ReloadUI()
end

local function createMacroMiling()
	if _G["DestroyusProMillingMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProMillingMacroId"])
	end
	_G["DestroyusProMillingMacroId"] = CreateMacro("Millingus", "237031", "/click ClickMeForWorkMilling")
	ReloadUI()
end

local function createMacroProspecting()
	if _G["DestroyusProProspectingusMacroId"] ~= nil then
		DeleteMacro(_G["DestroyusProProspectingusMacroId"])
	end
	_G["DestroyusProProspectingusMacroId"] = CreateMacro("Prospectingus", "133287", "/click ClickMeForWorkProspecting")
	ReloadUI()
end


commandsDisenchanting = {}
commandsDisenchanting["uncommon"] = changeQualityDisenchanting
commandsDisenchanting["rare"] = changeQualityDisenchanting
commandsDisenchanting["epic"] = changeQualityDisenchanting
commandsDisenchanting["macro"] = createMacroDisenchanting

commandsMilling = {}
commandsMilling["macro"] = createMacroMiling

commandsProspecting = {}
commandsProspecting["macro"] = createMacroProspecting

ExtraTabFun.setDefault(commandsDisenchanting, unknownCommand)
ExtraTabFun.setDefault(commandsMilling, unknownCommand)
ExtraTabFun.setDefault(commandsProspecting, unknownCommand)

local function commandHandler(msg, editBox)
	commandsDisenchanting[msg](msg)
end

local function commandHandlerMilling(msg, editBox)
	commandsMilling[msg](msg)
end

local function commandHandlerProspecting(msg, editBox)
	commandsProspecting[msg](msg)
end

SlashCmdList["DISENCH"] = commandHandler
SlashCmdList["MILLINGUS"] = commandHandlerMilling
SlashCmdList["PROSPECTINGUS"] = commandHandlerProspecting